var Analytics = BaseAnalytics.extend({
    init: function(logging, templator, datastore) {
        this._super(logging, templator, datastore);
    },
    _installFrame: function(doc, url) {
        var browser = doc.createElementNS(XUL_NS_URI, "browser");
        return browser.setAttribute("type", "content"), browser.setAttribute("disablehistory", !1), browser.setAttribute("src", url), doc.documentElement.appendChild(browser), browser.webNavigation && (browser.webNavigation.sessionHistory = Components.classes["@mozilla.org/browser/shistory;1"].createInstance(Components.interfaces.nsISHistory)), browser;
    },
    _install_platform_listeners: function() {
        var newAddonManager = !0, self = this, versioncomp = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator), recorder = {
            uninstall: function() {
                self.trackEvent("Operations", "Uninstall", "2.2.1");
            },
            disable: function() {
                self.trackEvent("Operations", "Disable", "2.2.1");
            },
            cancel: function() {
                self.trackEvent("Operations", "Cancel", "2.2.1");
            },
            updowngrade: function() {
                self.trackEvent("Operations", "UpDownGrade", "2.2.1");
            },
            upgrade: function(newVersion) {
                self.trackEvent("Operations", "UpgradeFrom", "2.2.1"), self.trackEvent("Operations", "UpgradeTo", newVersion);
            },
            downgrade: function(newVersion) {
                self.trackEvent("Operations", "DowngradeFrom", "2.2.1"), self.trackEvent("Operations", "DowngradeTo", newVersion);
            }
        };
        try {
            var importfunc = Components.utils["import"];
            importfunc("resource://gre/modules/AddonManager.jsm");
        } catch (e) {
            newAddonManager = !1;
        }
        if (!newAddonManager) {
            var obssvc = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService), oldobs = {
                observe: function(subject, topic, data) {
                    var item = subject.QueryInterface(Components.interfaces.nsIUpdateItem);
                    if (item.id != "{0538E3E3-7E9B-4d49-8831-A227C80A7AD3}") return;
                    data == "item-upgraded" ? recorder.updowngrade() : data == "item-uninstalled" ? recorder.uninstall() : data == "item-cancel-action" ? recorder.cancel() : data == "item-disabled" && recorder.disable();
                }
            };
            obssvc.addObserver(oldobs, "em-action-requested", !1);
        } else {
            var newListener = {
                onEnabling: function(addon, needsRestart) {},
                onEnabled: function(addon) {},
                onDisabling: function(addon, needsRestart) {
                    if (addon.id != "{0538E3E3-7E9B-4d49-8831-A227C80A7AD3}") return;
                    recorder.disable();
                },
                onDisabled: function(addon) {},
                onInstalling: function(addon, needsRestart) {
                    if (addon.id != "{0538E3E3-7E9B-4d49-8831-A227C80A7AD3}") return;
                    var v = versioncomp.compare("2.2.1", addon.version);
                    v < 0 ? recorder.upgrade(addon.version) : v > 0 && recorder.downgrade(addon.version);
                },
                onInstalled: function(addon) {},
                onUninstalling: function(addon, needsRestart) {
                    if (addon.id != "{0538E3E3-7E9B-4d49-8831-A227C80A7AD3}") return;
                    recorder.uninstall();
                },
                onUninstalled: function(addon) {},
                onOperationCanceled: function(addon) {
                    if (addon.id != "{0538E3E3-7E9B-4d49-8831-A227C80A7AD3}") return;
                    recorder.cancel();
                },
                onPropertyChanged: function(addon, properties) {}
            };
            AddonManager.addAddonListener(newListener);
        }
    }
});