(function($) {
    $.fn.ff = function(method) {
        if (methods[method]) return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        if (typeof method == "object" || !method) return methods.init.apply(this, arguments);
        $.error("Method " + method + " does not exist on jQuery.ff");
    };
    var methods = {}, CHANNEL_SET_PREF = "ui-set-pref", CHANNEL_ON_PREF_UPDATE = "ui-on-pref-update";
    methods.attach = function(preference, opts) {
        var settings = {
            type: "radio"
        };
        opts && $.extend(settings, opts), console.log("attaching " + settings.type + " to " + preference);
        var self = $(this), options = $(this).children(".option");
        $(options).unbind("click"), $(options).click(function(e) {
            if (settings.type == "multi") {
                console.log("multi click");
                if (e.ctrlKey || e.metaKey) {
                    var selection = $(options).filter(".selected").length + 1;
                    $(this).addClass("selected").attr("sindex", selection);
                } else $(options).removeClass("selected").attr("sindex", ""), $(this).addClass("selected").attr("sindex", "1");
            } else console.log("radio click"), $(options).removeClass("selected"), $(this).addClass("selected");
            observer.notify(CHANNEL_SET_PREF, {
                name: preference,
                value: $(self).ff("val")
            });
        }), observer.add(CHANNEL_ON_PREF_UPDATE, function(data) {
            preference in data && $(self).ff("val", data[preference]);
        });
    }, methods.val = function(val) {
        if (val === undefined) {
            var options = $(this).children(".option");
            if ($(options).filter(".yes").size()) return $(options).filter(".selected").hasClass("yes");
            var selected = $(options).filter(".selected");
            return $(selected).attr("sindex") !== "undefined" ? (selected.sort(function(a, b) {
                return $(a).attr("sindex") - $(b).attr("sindex");
            }), $.map(selected, function(e) {
                return $(e).attr("id").slice(2);
            })) : $(selected).attr("id").slice(2);
        }
        var options = $(this).children(".option").removeClass("selected");
        if (typeof val == "boolean") options.filter(val ? ".yes" : ".no").addClass("selected"); else if (typeof val == "string" || typeof val == "number") options.filter("#p-" + val).addClass("selected"); else if (val instanceof Array) {
            options.attr("sindex", "").children(".sindex").remove();
            for (var x = 0, len = val.length; x < len; x++) options.filter("#" + val[x]).addClass("selected").attr("sindex", x + 1).append('<span class="sindex">' + (x + 1) + "</span>");
        }
        return val;
    };
})(jQuery);