/*******************************************************************************
 * This is the main object that will interact with the browser's chrome.  The
 * services page we depend on is loaded into an iframe on the hidden window.
 * Any script files we need to depend on directly will be loaded into there on
 * scope using the subscript loader.
 *
 * @version 1.0
 ******************************************************************************/var ForecastfoxOverlay = {
    __proto__: Forecastfox,
    _initialized: !1,
    _logger: null,
    _templator: null,
    _observers: null,
    _customization_active: !1,
    onLoad: function() {
        if (this._initialized) return;
        var bgp = this.services(), self = this, callback = function() {
            bgp.removeEventListener("DOMContentLoaded", callback, !0), self._logger = bgp.logging.getLogger("overlay"), self._templator = new bgp.Templator(bgp.logging, document), self._observers = new bgp.Observers(bgp.logging), self._insert_spring(), self.render(), self._observers.add("feed-ready", function() {
                self.render();
            }), self._observers.add("feed-error", function() {
                self.render_error();
            }), self._observers.add("feed-updating", function(location) {
                self.render_progress(location);
            }), document.getElementById("forecastfox-popup").addEventListener("popupshowing", function() {
                self.render_context_menu();
            }, !1), getBrowser().addEventListener("DOMContentLoaded", function(e) {
                self.options_listener(e);
            }, !1), self._initialized = !0, self._logger.debug("initialized");
        };
        bgp.initialized ? setTimeout(callback, 0) : bgp.addEventListener("DOMContentLoaded", callback, !0);
    },
    options_listener: function(e) {
        var unsafeWin, href;
        (new XPCNativeWrapper(window)).mUntrustedObject ? (unsafeWin = (new XPCNativeWrapper((new XPCNativeWrapper(e, "target")).target, "defaultView")).defaultView, href = (new XPCNativeWrapper((new XPCNativeWrapper(unsafeWin, "location")).location, "href")).href) : (unsafeWin = e.target.defaultView, unsafeWin.wrappedJSObject && (unsafeWin = unsafeWin.wrappedJSObject), href = e.target.location.href);
        if (!/^http:\/\/www\.getforecastfox\.com\/customize\/([#]{0,1}(.*))$/i.test(href)) return;
        this._logger.debug("options_listener matched href: " + href), this.inject_content_script(unsafeWin);
    },
    inject_content_script: function(unsafeWin) {
        var bgp = Forecastfox.services();
        Forecastfox_Inject_Options_Script(bgp, unsafeWin), this._observers.notify("ui-content-script-loaded", {});
    },
    onUnload: function() {
        this._logger.debug("window closed. cleaning up overlay script."), this._observers.shutdown();
        var bgp = this.services();
        bgp.logging.removeLogger(this._logger), this._logger = null, this._templator = null, this._observers = null, this._initialized = !1;
    },
    render: function() {
        this._logger.debug("rendering");
        var bgp = this.services(), doc = this._templator._document, toolbar_prefs = bgp.preferences.preference("toolbar"), theme_prefs = bgp.preferences.preference("theme"), target_toolbar = toolbar_prefs.parent, target_position = toolbar_prefs.position, display = toolbar_prefs.display;
        bgp.positioner.update_position(window, target_toolbar, target_position);
        if (bgp.locations.is_error()) {
            this.render_error();
            return;
        }
        var key, data = bgp.locations.processed_data();
        if (!data) return;
        for (key in bgp.features) bgp.features[key].data(data);
        var toolbar = doc.getElementById("forecastfox-toolbar");
        while (toolbar.hasChildNodes()) toolbar.removeChild(toolbar.firstChild);
        var offset = this._calc_forecast_offset(data, toolbar_prefs), display_count = 0;
        for (key in bgp.features) {
            var feature = bgp.features[key];
            if (feature.disabled) continue;
            var panel = feature instanceof bgp.Forecast ? feature.toolbar(this._templator, "ffpanel", offset) : feature.toolbar(this._templator, "ffpanel");
            if (panel) {
                var classes = panel.className;
                classes = classes ? classes.split(" ") : [];
                if (feature instanceof bgp.CurrentConditions || feature instanceof bgp.Forecast) display_count++, classes.push(display_count <= display ? "text-image" : "image"); else if (feature instanceof bgp.DragTarget) continue;
                theme_prefs.separators && classes.push("separators"), panel.className = classes.join(" "), toolbar.appendChild(panel);
            }
        }
        this._add_os_attr(), this._customization_active && this.toggle_drag_icon(!0), this._rendered_location = bgp.locations.selected();
    },
    render_error: function() {
        this.remove_progress(), this._logger.debug("rendering error in toolbar");
        var bgp = this.services(), errorReporter = bgp.features.error, panel = errorReporter.toolbar(this._templator, "ffpanel", !0);
        this._replace_node("forecastfox-error", panel);
    },
    remove_progress: function() {
        var node = document.getElementById("forecastfox-progress");
        node && node.parentNode.removeChild(node);
    },
    render_progress: function(location) {
        this._logger.debug("rendering progress bar in toolbar");
        var bgp = this.services(), progress = bgp.features.progress, panel = progress.toolbar(this._templator, "ffpanel", location);
        this._replace_node("forecastfox-progress", panel);
    },
    _replace_node: function(node_id, new_node) {
        var old_node = document.getElementById(node_id), toolbar = document.getElementById("forecastfox-toolbar"), next_sibling = toolbar.firstChild;
        old_node && (next_sibling = old_node.nextSibling, old_node.parentNode.removeChild(old_node)), toolbar.insertBefore(new_node, next_sibling);
    },
    render_tooltip: function() {
        var feature = document.tooltipNode.feature, bgp = this.services(), tooltip = document.getElementById("forecastfox-tooltip-" + feature._id), bgp = this.services(), data = feature.data(), now = new Date, toolbar_prefs = bgp.preferences.preference("toolbar");
        try {
            bgp.analytics.trackPageview("/content/tooltip/" + feature._id);
        } catch (e) {
            this._logger.debug("ERROR: " + e);
        }
        var outer = FF_TEMPLATES.tooltip, layout = FF_TEMPLATES.details_double_layout, table = this._templator.render(FF_TEMPLATES.details_table, {
            image: bgp.themes.largeImage(data.icon)
        });
        data = {};
        var details;
        if (feature instanceof bgp.Forecast) {
            var day_feature, night_feature;
            feature._id.match("day") ? (day_feature = feature, night_feature = bgp.features[feature._id.replace("day", "night")]) : (day_feature = bgp.features[feature._id.replace("night", "day")], night_feature = feature), details = day_feature.details(this._templator, FF_TEMPLATES.details_row), data["top-panel"] = day_feature.general(this._templator, table), data["top-panel"] = this._templator.render(data["top-panel"], {
                details: details,
                links: "",
                right: ""
            }), details = night_feature.details(this._templator, FF_TEMPLATES.details_row), data["bottom-panel"] = night_feature.general(this._templator, table), data["bottom-panel"] = this._templator.render(data["bottom-panel"], {
                details: details,
                links: "",
                right: ""
            }), toolbar_prefs.days_or_nights == "days-nights" && (layout = FF_TEMPLATES.details_single_layout, feature._part == "day" ? (data.panel = data["top-panel"], data["class"] = "ff-content-top") : feature._part == "night" && (data.panel = data["bottom-panel"], data["class"] = "ff-content-bottom"));
        } else feature instanceof bgp.CurrentConditions ? (details = feature.details(this._templator, FF_TEMPLATES.details_row), layout = FF_TEMPLATES.details_single_layout, data.panel = feature.general(this._templator, table), data.panel = this._templator.render(data.panel, {
            details: details
        }), data["class"] = feature.is_night() ? "ff-content-bottom" : "ff-content-top") : feature instanceof bgp.Radar ? (layout = FF_TEMPLATES.details_single_layout, data.panel = feature.general(this._templator, FF_TEMPLATES.radar), data["class"] = "") : feature instanceof bgp.SWA && (layout = FF_TEMPLATES.details_single_layout, data.panel = feature.general(this._templator, FF_TEMPLATES.text), data["class"] = "ff-content-top");
        layout = this._templator.render(layout, data), layout = this._templator.render(outer, {
            header: this._rendered_location.name,
            details: layout
        }), tooltip = document.getAnonymousNodes(tooltip)[0];
        while (tooltip.hasChildNodes()) tooltip.removeChild(tooltip.firstChild);
        var ue = Components.classes["@mozilla.org/feed-unescapehtml;1"].getService(Components.interfaces.nsIScriptableUnescapeHTML), frag = ue.parseFragment(layout, !1, null, tooltip);
        bgp.i18n.rtl() ? (this._logger.debug("setting tooltip direction to rtl"), tooltip.className ? tooltip.className += " ff-rtl" : tooltip.className = "ff-rtl") : tooltip.className && (tooltip.className = tooltip.className.split("ff-rtl").join("").split(" ").join(""), this._logger.debug("returning tooltip to ltr")), this._logger.debug("tooltip className: " + tooltip.className), tooltip.appendChild(frag);
    },
    clean_tooltip: function() {
        this._logger.debug("cleaning tooltip");
        var tooltip = document.getElementById("forecastfox-tooltip");
        while (tooltip.hasChildNodes()) tooltip.removeChild(tooltip.firstChild);
    },
    render_context_menu: function() {
        var menus = document.getElementById("forecastfox-popup").childNodes, bgp = this.services(), i18n = bgp.i18n, locations = bgp.locations;
        for (var x = 0; x < menus.length; x++) {
            var menu = menus[x];
            menu.hasAttribute("localize") && menu.setAttribute("label", i18n.data(menu.getAttribute("localize")));
        }
    },
    render_location_selector: function() {
        var bgp = this.services(), locations = bgp.locations, recent_list = locations.saved(), menu = document.getElementById("forecastfox-locations-popup"), current = locations.selected(), self = this, newloc = document.getElementById("forecastfox-new-location");
        newloc.setAttribute("label", bgp.i18n.data(newloc.getAttribute("localize")));
        while (menu.hasChildNodes() && menu.lastChild.tagName != "menuseparator") menu.removeChild(menu.lastChild);
        for (var x = 0; x < recent_list.length; x++) {
            var node = document.createElement("menuitem");
            node.location = recent_list[x], node.setAttribute("label", recent_list[x].name), node.setAttribute("type", "radio"), node.addEventListener("command", function() {
                self._logger.debug("selected location: " + this.location.name), locations.selected(this.location);
            }, !1), recent_list[x].code == current.code && node.setAttribute("checked", "true"), menu.appendChild(node);
        }
    },
    toggle_drag_icon: function(enable) {
        var bgp = this.services(), node = null, toolbar = document.getElementById("forecastfox-toolbar"), feature = bgp.features["drag-target"], theme_prefs = bgp.preferences.preference("theme");
        this._customization_active = enable;
        if (enable) {
            node = feature.toolbar(this._templator, "ffpanel");
            var classes = node.className;
            classes = classes ? classes.split(" ") : [], theme_prefs.separators && classes.push("separators"), node.className = classes.join(" "), node.addEventListener("draggesture", ForecastfoxDropTargetObserver.onDragGestureHandle, !1), toolbar.insertBefore(node, toolbar.firstChild);
        } else node = document.getElementById("forecastfox-drag-target"), node.removeEventListener("draggesture", ForecastfoxDropTargetObserver.onDragGestureHandle, !1), node.parentNode.removeChild(node);
    },
    _calc_forecast_offset: function(data, toolbar_prefs) {
        var obsdate = new Date(data.forecast[0].day.date), now = new Date(obsdate.toDateString() + " " + data.cc.time_raw), today = new Date(now.toDateString()), hour = now.getHours(), date_offset = obsdate < today ? 2 : 0, partial_day_offset = hour >= 15 ? 1 : 0;
        return date_offset + partial_day_offset;
    },
    _add_os_attr: function() {
        var runtime = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime);
        document.getElementById("forecastfox-toolbar").setAttribute("OS", runtime.OS);
    },
    _insert_spring: function() {
        var prefs = this.services().preferences;
        if (prefs.preference("spring_inserted")) return;
        prefs.preference("spring_inserted", !0);
        var toolbar = document.getElementById("toolbar-menubar"), toolbox = toolbar.parentNode, toolboxDoc = toolbox.ownerDocument, setItems = toolbar.currentSet.split(",");
        setItems.push("forecastfox-menubar-spring");
        var newSet = setItems.join(",");
        toolbar.currentSet = newSet, toolbar.setAttribute("currentset", newSet), toolboxDoc.persist(toolbar.id, "currentset");
        try {
            BrowserToolboxCustomizeDone(!0);
        } catch (e) {
            this._logger.exception("inserting spring", e);
        }
    }
};