var ForecastfoxDropTargetObserver;

(function() {
    var VALID_BARS = [ "toolbar", "statusbar", "menubar" ], gCurrentDragOverItem = null, dropTargetObserver = {
        onDragStart: function(event, transferData, action) {
            transferData.data = new TransferData, transferData.data.addDataForFlavour("id/forecastfox-toolbar", "forecastfox-toolbar"), toggleDragListeners(!0);
        },
        onDragOver: function(event, flavor, session) {
            try {
                var toolbar = event.target, dropTarget = event.target;
                while (toolbar && !isToolbar(toolbar)) dropTarget = toolbar, toolbar = toolbar.parentNode;
                var previousDragItem = gCurrentDragOverItem;
                if (!isToolbar(toolbar)) {
                    gCurrentDragOverItem && toggleDragMarkers(gCurrentDragOverItem, !1), gCurrentDragOverItem = null;
                    return;
                }
                if (isToolbar(dropTarget)) gCurrentDragOverItem = dropTarget; else if ("boxObject" in dropTarget) {
                    gCurrentDragOverItem = null;
                    var dropTargetCenter = dropTarget.boxObject.x + dropTarget.boxObject.width / 2, dragAfter = event.clientX > dropTargetCenter;
                    if (dragAfter) {
                        gCurrentDragOverItem = dropTarget.nextSibling;
                        while (isHidden(gCurrentDragOverItem)) gCurrentDragOverItem = gCurrentDragOverItem.nextSibling;
                        gCurrentDragOverItem == null && (gCurrentDragOverItem = toolbar);
                    } else gCurrentDragOverItem = dropTarget;
                } else gCurrentDragOverItem = null;
                previousDragItem && gCurrentDragOverItem != previousDragItem && toggleDragMarkers(previousDragItem, !1), toggleDragMarkers(gCurrentDragOverItem, !0), session.canDrop = !0;
            } catch (e) {}
        },
        onDragExit: function(event, session) {
            gCurrentDragOverItem != null && toggleDragMarkers(gCurrentDragOverItem, !1);
        },
        onDrop: function(event, dropData, session) {
            toggleDragListeners(!1);
            if (gCurrentDragOverItem == null) return;
            toggleDragMarkers(gCurrentDragOverItem, !1);
            if (dropData.data == gCurrentDragOverItem.getAttribute("id")) return;
            var toolbar = event.target;
            while (toolbar && !isToolbar(toolbar)) toolbar = toolbar.parentNode;
            var toolbarId = toolbar.getAttribute("id"), toolbarPosition = getPosition(gCurrentDragOverItem);
            savePosition(toolbarId, toolbarPosition), gCurrentDragOverItem = null;
        },
        getSupportedFlavours: function() {
            var flavours = new FlavourSet;
            return flavours.appendFlavour("id/forecastfox-toolbar"), flavours;
        },
        onDragGestureHandle: function(event) {
            nsDragAndDrop.startDrag(event, dropTargetObserver);
        }
    };
    function savePosition(toolbar, position) {
        var bgp = Forecastfox.services(), prefs = bgp.preferences, p = prefs.preference("toolbar");
        p.parent = toolbar, p.position = position, prefs.preference("toolbar", p);
    }
    function getPosition(node) {
        if (isToolbar(node)) return "last";
        var parent = node.parentNode, siblings = parent.childNodes, index = -1, offset = 0;
        for (var x = 0; x < siblings.length; x++) {
            siblings[x].getAttribute("id") == "forecastfox-toolbar" && (offset = -1);
            if (siblings[x] == node) {
                index = x;
                break;
            }
        }
        return index == siblings.length - 1 ? "right" : index + offset;
    }
    function isHidden(node) {
        return node ? node.localName == "menupopup" ? !0 : node.hasAttribute("collapsed") || node.hasAttribute("hidden") : !1;
    }
    function isToolbar(node) {
        return node ? node.localName == "toolbar" || node.localName == "statusbar" || node.localName == "menubar" : !1;
    }
    function toggleDragListeners(enable) {
        var targetBars = [ "navigator-toolbox", "status-bar" ];
        for (var x = 0; x < targetBars.length; x++) {
            var barId = targetBars[x], bar = document.getElementById(barId), toggleEventListener = enable ? bar.addEventListener : bar.removeEventListener;
            toggleEventListener("dragover", onDragOverHandler, !0), toggleEventListener("dragexit", onDragExitHandler, !0), toggleEventListener("dragdrop", onDragDropHandler, !0), toggleEventListener("drop", onDragDropHandler, !0);
        }
    }
    function toggleDragMarkers(node, enable) {
        var value = "left", target = node;
        if (isToolbar(target)) {
            target = node.lastChild;
            while (isHidden(target)) target = target.previousSibling;
            value = "right";
        }
        if (!target) return;
        enable ? target.hasAttribute("ff-dragover") || target.setAttribute("ff-dragover", value) : target.removeAttribute("ff-dragover");
    }
    function onDragOverHandler(event) {
        nsDragAndDrop.dragOver(event, dropTargetObserver);
    }
    function onDragExitHandler(event) {
        nsDragAndDrop.dragExit(event, dropTargetObserver);
    }
    function onDragDropHandler(event) {
        nsDragAndDrop.drop(event, dropTargetObserver);
    }
    ForecastfoxDropTargetObserver = dropTargetObserver;
})();